package clasesJava;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class ConsultaDates
 */
public class ConsultaDates extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ConsultaDates() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		int diaI = Integer.parseInt(request.getParameter("diaInici"));
		int mesI = Integer.parseInt(request.getParameter("mesInici"))-1;
		int anyI = Integer.parseInt(request.getParameter("anyInici"));
		int diaF = Integer.parseInt(request.getParameter("diaFi"));
		int mesF = Integer.parseInt(request.getParameter("mesFi"))-1;
		int anyF = Integer.parseInt(request.getParameter("anyFi"));
		Calendar cal = new GregorianCalendar();
		cal.set(anyI,mesI,diaI);
		Date dataInici = cal.getTime();
		cal.set(anyF,mesF,diaF);
		Date dataFi = cal.getTime();
		
		PerDates pd = new PerDates();
		List <Cert> lista = null;
		String r1="";
		
		try {
			lista = pd.llistaPerDates(dataInici, dataFi);
		}catch (SQLException e) {
			System.out.println("ERROR: Problemes amb la BD");
			e.printStackTrace();
		}
		
		// Convertir la lista en un fichero y mandarlo
		FileWriter fichero = null;
        PrintWriter pw = null;
        
        // Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			r1=prop.getProperty("rutaC3");
			
			try
	        {
	            fichero = new FileWriter(r1);
	            pw = new PrintWriter(fichero);
	            
	            Iterator iter = lista.iterator();
	            while (iter.hasNext()){
	            	String revo=iter.next().toString();
	            	pw.println(revo);
	            	lista.iterator().next();
	            }

	        } catch (Exception e) {
	            e.printStackTrace();
	        } finally {
	           try {
	           // Nuevamente aprovechamos el finally para 
	           // asegurarnos que se cierra el fichero.
	           if (null != fichero)
	              fichero.close();
	           } catch (Exception e2) {
	              e2.printStackTrace();
	           }
        
	        }
	        
        } catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
        
        response.setContentType("application/octet-stream");
        response.setHeader("Content-Disposition","attachment;filename=ConsultaPerDates");
        
        try 
    	{
        	String ruta = r1;
        	File file = new File(ruta);
        	FileInputStream fileIn = new FileInputStream(file);
        	ServletOutputStream out = response.getOutputStream();
        	 
        	byte[] outputByte = new byte[4096];
        	//copy binary contect to output stream
        	while(fileIn.read(outputByte, 0, 4096) != -1)
        	{
        		out.write(outputByte, 0, 4096);
        	}
        	fileIn.close();
        	out.flush();
        	out.close();
     
    	  } finally{
    	  }
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
