package clasesJava;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class EnviarCRL
 */
public class EnviarCRL extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public EnviarCRL() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("rutaCRL");
			
			response.setContentType("application/octet-stream");
	        response.setHeader("Content-Disposition","attachment;filename=CRLactualitzada");
	        
	        try 
	    	{
	        	String ruta = r1;
	        	File file = new File(ruta);
	        	FileInputStream fileIn = new FileInputStream(file);
	        	ServletOutputStream out = response.getOutputStream();
	        	 
	        	byte[] outputByte = new byte[4096];
	        	//copy binary contect to output stream
	        	while(fileIn.read(outputByte, 0, 4096) != -1)
	        	{
	        		out.write(outputByte, 0, 4096);
	        	}
	        	fileIn.close();
	        	out.flush();
	        	out.close();
	     
	    	  } finally{
	    	  }
		}catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
		
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
