package clasesJava;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class PerNom {
	
	/**
	 * Constructor per defecte
	 */
	public PerNom(){
	}
	
	/**
	 * Connects, inserts and disconnetcs.
	 * @param args Method parameters
	 * @throws SQLException 
	 * @throws ClassNotFoundException 
	 * @throws IOException 
	 */
	public List<Cert> llistaPerNom(String nombre) throws SQLException {
		List<Cert> lista=null;
		Connection con = null;

		try {
			con = AccesoBD.getConnection();
		} catch (IOException e1) {
			System.out.println("ERROR: Problemes d'entrada-sortida");
			e1.printStackTrace();
		} catch (ClassNotFoundException e1) {
			System.out.println("ERROR: Classe no trobada");
			e1.printStackTrace();
		}
		con.setAutoCommit(false);
		try {
			lista = llistaPerNom(con,nombre);
			con.commit();
		}
		catch (SQLException e){
			System.out.println("ERROR: Unexpected error: " + e.getMessage());
		}
		catch (Exception e) {
			con.rollback();
			System.out.println("ERROR (" + e.getClass() + "): " + e.getMessage());
		}

		AccesoBD.closeConnection(con);
		
		return lista;
	}
	
	public List<Cert> llistaPerNom(Connection con, String nombre){
		List<Cert> lista = new ArrayList<Cert>();
		ResultSet rs;
		String sql1 = "SELECT * FROM certificados WHERE (nom=? OR cognom1=? OR cognom2=?)";
		
		PreparedStatement pst;
		try {
			pst = con.prepareStatement(sql1);
			pst.clearParameters();
			pst.setString(1,nombre);
			pst.setString(2,nombre);
			pst.setString(3,nombre);
			rs = pst.executeQuery();
			while (rs.next()){
				int serial = Integer.parseInt(rs.getString(1));
				String nom = rs.getString(2);
				String cognom1 = rs.getString(3);
				String cognom2 = rs.getString(4);
				Date dataInici = rs.getDate(5);
				Date dataFi = rs.getDate(6);
				boolean valido = rs.getBoolean(7);
				Cert cert =new Cert(serial, nom, cognom1, cognom2,dataInici,dataFi,valido);
				lista.add(cert);
			}
			pst.close();
		} catch (SQLException e) {
			System.out.println("ERROR: Unexpected error: " + e.getMessage());
			e.printStackTrace();
		}
		
		return lista;
	}

}
