package clasesJava;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class RevocaCerti {
	
	/**
	 * Default constructor.
	 */
	public RevocaCerti(){
	}
	
	/**
	 * Revoques a cert in the database
	 * @param nom, cognom1, cognom2
	 * @throws SQLException 
	 */
	public int revocarCertBD (Connection con, String nom, String cognom1, String cognom2) throws SQLException
		 {
		
		String sql1 = "UPDATE  certificados SET valido=false WHERE nom=? AND cognom1=? AND cognom2=?";
		
		PreparedStatement pst = con.prepareStatement(sql1);
		pst.clearParameters();
		pst.setString(1,nom);
		pst.setString(2,cognom1);
		pst.setString(3,cognom2);
		int nombre = pst.executeUpdate();
		pst.close();
		
		return nombre;
			
	}
	
	/**
	 * Connects, inserts and disconnetcs.
	 * @param args Method parameters
	 * @throws SQLException 
	 * @throws ClassNotFoundException 
	 * @throws IOException 
	 */
	public int revocarCert(String nom, String cognom1, String cognom2) throws SQLException {
		int nombre=0;
		Connection con = null;

		try {
			con = AccesoBD.getConnection();
		} catch (IOException e1) {
			System.out.println("ERROR: Problemes d'entrada-sortida");
			e1.printStackTrace();
		} catch (ClassNotFoundException e1) {
			System.out.println("ERROR: Classe no trobada");
			e1.printStackTrace();
		}
		con.setAutoCommit(false);
		try {
			nombre = revocarCertBD(con, nom, cognom1, cognom2);
			con.commit();
		}
		catch (SQLException e){
			System.out.println("ERROR: Unexpected error: " + e.getMessage());
		}
		catch (Exception e) {
			con.rollback();
			System.out.println("ERROR (" + e.getClass() + "): " + e.getMessage());
		}

		AccesoBD.closeConnection(con);
		
		return nombre;
	}

}
