package clasesJava;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class Usuari1
 */
public class Usuari1 extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Usuari1() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String arxiu = "";
		String nom = request.getParameter("nom");
		String cognom1 = request.getParameter("cognom1");
		String cognom2 = request.getParameter("cognom2");
		int dia = Integer.parseInt(request.getParameter("dia"));
		int mes = Integer.parseInt(request.getParameter("mes"))-1;
		int any = Integer.parseInt(request.getParameter("any"));
		Calendar cal = new GregorianCalendar();
		cal.set(any,mes,dia);
		Date dataInici = cal.getTime();
		cal.add(Calendar.YEAR, 1);
		Date dataFi = cal.getTime();
		
		Cert cert = new Cert(nom,cognom1,cognom2,dataInici,dataFi);
		InsertaCerti ic = new InsertaCerti();
		try {
			arxiu = ic.insertarCert(cert);
			
		} catch (ClassNotFoundException e) {
			System.out.println("ERROR: Classe inexistent");
			e.printStackTrace();
		} catch (SQLException e) {
			System.out.println("ERROR: Problemes amb la BD");
			e.printStackTrace();
		}
		
		response.setContentType("application/octet-stream");
        response.setHeader("Content-Disposition","attachment;filename=certificat");
        
        try 
    	{
        	File file = new File(arxiu);
        	FileInputStream fileIn = new FileInputStream(file);
        	ServletOutputStream out = response.getOutputStream();
        	 
        	byte[] outputByte = new byte[4096];
        	//copy binary contect to output stream
        	while(fileIn.read(outputByte, 0, 4096) != -1)
        	{
        		out.write(outputByte, 0, 4096);
        	}
        	fileIn.close();
        	out.flush();
        	out.close();
     
    	  } finally{
    	  }
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}

