package clasesJava;

import java.io.File;
import java.io.FileInputStream;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PublicKey;
import java.security.Security;
//import java.security.Security;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.Date;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.bouncycastle.jce.PKCS10CertificationRequest;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
//import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.util.encoders.Base64;


/**
 * Servlet implementation class Usuari2
 */
public class Usuari2 extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Usuari2() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String arxiu="";
		String nom="";
		String cognom1="";
		String cognom2="";
		Calendar cal = Calendar.getInstance();
		Date dataInici = cal.getTime();
		cal.add(Calendar.YEAR, 1);
		Date dataFi = cal.getTime();
		
		//Llegim l'arxiu per trobar el nom d'usuari
		String nom1="C:/TFC/Peticion";
		
		// Construir el archivo temporal. 
		File tempPet = new File(nom1+ ".tmp" );
		
		BufferedReader br = new BufferedReader (new FileReader (nom1)); 
		PrintWriter pw = new PrintWriter( new FileWriter(tempPet));

		String lactual = null ;
		String lprox = null;
		
		// Leer la primera fila y no hacer nada 
		lactual = br.readLine();
		lactual = "";
		
		// Leer las siguientes lneas
		while ((lprox = br.readLine ())!= null) {
			pw.println(lactual);
			pw.flush();
			lactual = lprox;
			lprox=null;
		}
		
		pw.close();
		br.close();

		byte[] bufferPet = new byte[5000];
		FileInputStream in = new FileInputStream(nom1+".tmp");
		in.read(bufferPet, 0, 5000);
		in.close();
		byte[] req = Base64.decode(bufferPet);
		PKCS10CertificationRequest peticio = new PKCS10CertificationRequest(req);
		String nombre = peticio.getCertificationRequestInfo().getSubject().toString();
		int pos = nombre.indexOf("CN=")+3;
		String usuari= nombre.substring(pos);
		String [] campos = usuari.split("\\s+");  
		nom = campos[0];
		cognom1 = campos[1];
		cognom2 = campos [2];
		
		// Inserim el "certificat" a la base de dades
		Cert cert = new Cert(nom,cognom1,cognom2,dataInici,dataFi);
		InsertaCerti ic = new InsertaCerti();
		try {
			Security.addProvider(new BouncyCastleProvider());
			PublicKey clauPubUs = peticio.getPublicKey();
			arxiu = ic.insertarCert(cert,clauPubUs);
			
		} catch (ClassNotFoundException e) {
			System.out.println("ERROR: Classe inexistent");
			e.printStackTrace();
		} catch (SQLException e) {
			System.out.println("ERROR: Problemes amb la BD");
			e.printStackTrace();
		}catch (InvalidKeyException e1) {
			System.out.println("ERROR: Clau invlida");
			e1.printStackTrace();
		} catch (NoSuchAlgorithmException e1) {
			System.out.println("ERROR: Algorisme inexistent");
			e1.printStackTrace();
		} catch (NoSuchProviderException e1) {
			System.out.println("ERROR: El proveidor de seguretat no existeix");
			e1.printStackTrace();
		}
		
		response.setContentType("application/octet-stream");
        response.setHeader("Content-Disposition","attachment;filename=certificat");
        
        try 
    	{
        	File file = new File(arxiu);
        	FileInputStream fileIn = new FileInputStream(file);
        	ServletOutputStream out = response.getOutputStream();
        	 
        	byte[] outputByte = new byte[4096];
        	//copy binary contect to output stream
        	while(fileIn.read(outputByte, 0, 4096) != -1)
        	{
        		out.write(outputByte, 0, 4096);
        	}
        	fileIn.close();
        	out.flush();
        	out.close();
     
    	  } finally{
    	  }
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response, String archivo) throws ServletException, IOException {
		doGet(request, response);
	}

}
