package clasesJava;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.x509.X509V3CertificateGenerator;
import javax.security.auth.x500.X500Principal;
import java.security.*;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.X509Certificate;
import java.security.cert.Certificate;
import java.security.spec.*;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Properties;
import java.math.BigInteger;

public class certificatCA {
	
	/**
	 * Constructor per defecte
	 */
	public certificatCA(){
	}
	
	public void generaCertificatCA(){
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("clauCApriv");
			String r2=prop.getProperty("clauCApub");
			String r3=prop.getProperty("certiCA");
			String r4=prop.getProperty("magatzem");
			String r5=prop.getProperty("pswd1");
			String r6=prop.getProperty("pswd2");
			
			// Afegir provider BC
			Security.addProvider(new BouncyCastleProvider());
				            
			System.out.println("Iniciem la generaci del certificat");
			
			Date startDate = new java.util.Date();						// Moment d'inici de la validesa del certificat
			Calendar cal = new GregorianCalendar(); 
			cal.setTime(startDate);
			cal.add(Calendar.YEAR, 1);
			Date expiryDate = cal.getTime();							// Moment d'expiraci (un any ms tard)del certificat
			BigInteger serialNumber = new java.math.BigInteger("1");	// Nombre de serie del certificat
			X509Certificate certCA = null;

			// Ara recuperem la clau privada i la clau pblica i les introduim al keyPair
			KeyFactory keyFactoryRSA;
			try {
				keyFactoryRSA = KeyFactory.getInstance("RSA", "BC");
				
				try {
					// Primer la clau privada
					byte[] bufferPriv = new byte[5000];
					FileInputStream in = new FileInputStream(r1);
					in.read(bufferPriv, 0, 5000);
					in.close();
					PKCS8EncodedKeySpec clauPrivadaSpec = new PKCS8EncodedKeySpec(bufferPriv);
					PrivateKey clauPrivada;
					clauPrivada = keyFactoryRSA.generatePrivate(clauPrivadaSpec);
					System.out.println("Clau privada recuperada del disc");
					
					// Ara la clau pblica
					byte[] bufferPub = new byte[5000];
					in = new FileInputStream(r2);
					in.read(bufferPub, 0, 5000);
					in.close();
					X509EncodedKeySpec clauPublicaSpec = new X509EncodedKeySpec(bufferPub);
					PublicKey clauPublica;
					clauPublica = keyFactoryRSA.generatePublic(clauPublicaSpec);
					System.out.println("Clau pblica recuperada del disc");
					
					// Ara generem el keyPair
					KeyPair parellDeClaus = new KeyPair(clauPublica,clauPrivada);		// Parell de claus pblica/privada
					System.out.println("Parell de claus generat a partir de les claus recuperades");
					
					X509V3CertificateGenerator certGen = new X509V3CertificateGenerator();
					X500Principal dnName = new X500Principal("CN=Criptotal");

					certGen.setSerialNumber(serialNumber);
					certGen.setIssuerDN(dnName);
					certGen.setNotBefore(startDate);
					certGen.setNotAfter(expiryDate);
					certGen.setSubjectDN(dnName);                       		// Nota: El mateix que al issuer
					certGen.setPublicKey(parellDeClaus.getPublic());
					certGen.setSignatureAlgorithm("SHA256WithRSAEncryption");
					System.out.println("certGenerator generat");

					try {
						// Generem el certificat
						certCA = certGen.generate(parellDeClaus.getPrivate(), "BC");
						System.out.println("Certificat generat");
						
						// Cormprovaci del certificat
					    certCA.checkValidity(new Date());

					    certCA.verify(certCA.getPublicKey());

					    System.out.println("Certificat validat");
					      
					    // Guardem el certificat i la clau privada a un keyStore
					    KeyStore magatzem = KeyStore.getInstance("PKCS12", "BC");

					    // Inicialitzem
					    magatzem.load(null, null);
					    char[] contrasenya = r5.toCharArray();
					    String aliasCA = r5;
					    magatzem.setCertificateEntry(aliasCA, certCA);
					    Certificate[] cadena = new Certificate[1];
					    cadena[0] = certCA;
					    magatzem.setKeyEntry(aliasCA, clauPrivada, contrasenya, cadena);
					    System.out.println("Keystore generat");
					    
					    // Guardem el certificat
					    FileOutputStream out = new FileOutputStream(r3);
						out.write(certCA.getEncoded());
						out.close();
						System.out.println("Certificat guardat al disc (s un caprici)");
						
						//Guardem el Keystore
						out = new FileOutputStream(r4);
						char[] password = r6.toCharArray();
					    magatzem.store(out, password);
					    out.close();
					    System.out.println("Keystore guardat");
						
					} catch (CertificateEncodingException e) {
						System.out.println("Codificaci del Certificat no vlida");
						e.printStackTrace();
					} catch (InvalidKeyException e) {
						System.out.println("Clau no vlida");
						e.printStackTrace();
					} catch (IllegalStateException e) {
						System.out.println("Estat no vlid");
						e.printStackTrace();
					} catch (SignatureException e) {
						System.out.println("Signatura no vlida");
						e.printStackTrace();
					} catch (CertificateExpiredException e) {
						System.out.println("Certificat expirat");
						e.printStackTrace();
					} catch (CertificateNotYetValidException e) {
						System.out.println("Certificat encara no vlid");
						e.printStackTrace();
					} catch (CertificateException e) {
						System.out.println("Certificat no vlid");
						e.printStackTrace();
					} catch (KeyStoreException e) {
						System.out.println("KeyStore no vlid");
						e.printStackTrace();
					}
					
				} catch (InvalidKeySpecException e) {
					System.out.println("KeySpec no vlid");
					e.printStackTrace();
				}
				
			} catch (NoSuchAlgorithmException e) {
				System.out.println("No existeix aquest algorisme");
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				System.out.println("No existeix aquest proveidor de seguretat");
				e.printStackTrace();
			}catch (FileNotFoundException e) {
				System.out.println("El fitxer no existeix");
			} catch (IOException e) {
				System.out.println("Problemes de lectura/escriptura");
			}
			
		} catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
		
		return;
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
