package clasesJava;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.bouncycastle.asn1.DERIA5String;
import org.bouncycastle.asn1.DERSequence;
import org.bouncycastle.asn1.x509.DistributionPoint;
import org.bouncycastle.asn1.x509.DistributionPointName;
import org.bouncycastle.asn1.x509.GeneralName;
import org.bouncycastle.asn1.x509.GeneralNames;
import org.bouncycastle.asn1.x509.X509Extensions;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.bouncycastle.x509.X509V3CertificateGenerator;
import org.bouncycastle.x509.extension.AuthorityKeyIdentifierStructure;
import org.bouncycastle.x509.extension.SubjectKeyIdentifierStructure;
import javax.security.auth.x500.X500Principal;
import java.security.*;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.security.cert.Certificate;
import java.security.spec.*;
import java.util.Date;
import java.util.Properties;
import java.math.BigInteger;

public class certificatUsuari {
	
	/**
	 * Constructor per defecte
	 */
	public certificatUsuari(){
	}
	
	public String generaCertificatUsuari(int nombre, String usuari, Date startDate, Date expiryDate){
		
		String nom5="";
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("rutaUS");
			String r2=prop.getProperty("clauCApriv");
			String r3=prop.getProperty("magatzem");
			String r4=prop.getProperty("pswd2");
			String r5=prop.getProperty("pswd1");
			String r6=prop.getProperty("magatzemUS");
			String r7=prop.getProperty("URLCRL");
			
			// Afegir provider BC
			Security.addProvider(new BouncyCastleProvider());
				            
			X509Certificate certUS = null;
			PrivateKey CAKey = null;
			X509Certificate CAcert = null;

			// Ara recuperem la clau privada i la clau pblica de l'usuari i les introduim al keyPair
			KeyFactory keyFactoryRSA;
			try {
				keyFactoryRSA = KeyFactory.getInstance("RSA", "BC");
				
				try {
					// Primer la clau privada
					String nom1=r1+nombre+".privada";
					byte[] bufferPriv = new byte[5000];
					FileInputStream in = new FileInputStream(nom1);
					in.read(bufferPriv, 0, 5000);
					in.close();
					PKCS8EncodedKeySpec clauPrivadaSpec = new PKCS8EncodedKeySpec(bufferPriv);
					PrivateKey clauPrivada;
					clauPrivada = keyFactoryRSA.generatePrivate(clauPrivadaSpec);
					
					// Ara la clau pblica
					String nom2 =r1+nombre+".publica";
					byte[] bufferPub = new byte[5000];
					in = new FileInputStream(nom2);
					in.read(bufferPub, 0, 5000);
					in.close();
					X509EncodedKeySpec clauPublicaSpec = new X509EncodedKeySpec(bufferPub);
					PublicKey clauPublica;
					clauPublica = keyFactoryRSA.generatePublic(clauPublicaSpec);
					
					// Ara generem el keyPair
					KeyPair parellDeClausUS = new KeyPair(clauPublica,clauPrivada);		// Parell de claus pblica/privada
					
					// Ara recuperem la clau privada de la CA
					String nom3=r2;
					byte[] bufferPrivCA = new byte[5000];
					in = new FileInputStream(nom3);
					in.read(bufferPrivCA, 0, 5000);
					in.close();
					clauPrivadaSpec = new PKCS8EncodedKeySpec(bufferPrivCA);
					CAKey = keyFactoryRSA.generatePrivate(clauPrivadaSpec);
					
					// Ara recuperem el certificat de la CA
					String nom4=r3;
					char[] password = r4.toCharArray();
					KeyStore magatzem = KeyStore.getInstance("PKCS12", "BC");
					in = new FileInputStream(nom4);
					magatzem.load(in, password);
					in.close();
					CAcert = (X509Certificate) magatzem.getCertificate("Criptotal");
					
					X509V3CertificateGenerator certGen = new X509V3CertificateGenerator();
					String sujeto = "CN="+usuari;
					X500Principal dnName = new X500Principal(sujeto);
					
					BigInteger serialNumber = BigInteger.valueOf(nombre);
					certGen.setSerialNumber(serialNumber);
					certGen.setIssuerDN(CAcert.getSubjectX500Principal());
					certGen.setNotBefore(startDate);
					certGen.setNotAfter(expiryDate);
					certGen.setSubjectDN(dnName);                       		// Nota: El mateix que al issuer
					certGen.setPublicKey(parellDeClausUS.getPublic());
					certGen.setSignatureAlgorithm("SHA256WithRSAEncryption");
					
					GeneralName gn = new GeneralName(GeneralName.uniformResourceIdentifier,new DERIA5String(r7));
					GeneralNames gns = new GeneralNames(new DERSequence(gn)); 
					DistributionPointName dpn = new DistributionPointName(0, gns); 
					DistributionPoint distp = new DistributionPoint(dpn, null, null); 
					certGen.addExtension(X509Extensions.CRLDistributionPoints, false, new DERSequence(distp));
					
					certGen.addExtension(X509Extensions.AuthorityKeyIdentifier, false, new AuthorityKeyIdentifierStructure(CAcert));
					certGen.addExtension(X509Extensions.SubjectKeyIdentifier, false, new SubjectKeyIdentifierStructure(parellDeClausUS.getPublic()));

					try {
						// Generem el certificat
						certUS = certGen.generate(CAKey, "BC");
						
						// Cormprovaci del certificat
					    certUS.checkValidity(new Date());

					    certUS.verify(CAcert.getPublicKey());
					    				    
					    // Guardem el certificat i la clau privada a un keyStore
					    KeyStore magatzemUS = KeyStore.getInstance("PKCS12", "BC");
					    
					    // El fiquem al Keystore
					    magatzemUS.load(null, null);
					    char[] contrasenya = r5.toCharArray();
					    String aliasUS = "Usuari"+nombre;
					    magatzemUS.setCertificateEntry(aliasUS, certUS);
					    Certificate[] cadena = new Certificate[1];
					    cadena[0] = certUS;
					    magatzemUS.setKeyEntry(aliasUS, clauPrivada, contrasenya, cadena);
						
						//Guardem el Keystore
						nom5 = r6+nombre;
						FileOutputStream out = new FileOutputStream(nom5);
						password = r4.toCharArray();
					    magatzemUS.store(out, password);
					    out.close();
						
					} catch (CertificateEncodingException e) {
						System.out.println("Codificaci del Certificat no vlida");
						e.printStackTrace();
					} catch (IllegalStateException e) {
						System.out.println("Estat no vlid");
						e.printStackTrace();
					} catch (SignatureException e) {
						System.out.println("Signatura no vlida");
						e.printStackTrace();
					} catch (CertificateExpiredException e) {
						System.out.println("Certificat expirat");
						e.printStackTrace();
					} catch (CertificateNotYetValidException e) {
						System.out.println("Certificat encara no vlid");
						e.printStackTrace();
					} 
					
				} catch (InvalidKeySpecException e) {
					System.out.println("KeySpec no vlid");
					e.printStackTrace();
				} catch (KeyStoreException e) {
					System.out.println("KeyStore no vlid");
					e.printStackTrace();
				} catch (CertificateException e) {
					System.out.println("Certificat no vlid");
					e.printStackTrace();
				} catch (InvalidKeyException e) {
					System.out.println("Clau no vlida");
					e.printStackTrace();
				}
				
			} catch (NoSuchAlgorithmException e) {
				System.out.println("No existeix aquest algorisme");
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				System.out.println("No existeix aquest proveidor de seguretat");
				e.printStackTrace();
			}catch (FileNotFoundException e) {
				System.out.println("El fitxer no existeix");
			} catch (IOException e) {
				System.out.println("Problemes de lectura/escriptura");
			}
		
		} catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
		
		return nom5;
	}
	
	public String generaCertificatUsuari2(int nombre, String usuari, Date startDate, Date expiryDate, PublicKey clauPub){
		
		String nom5="";
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("rutaUS");
			String r2=prop.getProperty("clauCApriv");
			String r3=prop.getProperty("magatzem");
			String r4=prop.getProperty("pswd2");
			String r5=prop.getProperty("pswd1");
			String r6=prop.getProperty("magatzemUS");
			String r7=prop.getProperty("URLCRL");
			
			// Afegir provider BC
			Security.addProvider(new BouncyCastleProvider());
				            
			X509Certificate certUS = null;
			PrivateKey CAKey = null;
			X509Certificate CAcert = null;
			KeyFactory keyFactoryRSA;
			try {
				keyFactoryRSA = KeyFactory.getInstance("RSA", "BC");
				
				// Ara recuperem la clau privada de la CA
				String nom3=r2;
				byte[] bufferPrivCA = new byte[5000];
				FileInputStream in;
				in = new FileInputStream(nom3);
				in.read(bufferPrivCA, 0, 5000);
				in.close();
					
				PKCS8EncodedKeySpec clauPrivadaSpec = new PKCS8EncodedKeySpec(bufferPrivCA);
				CAKey = keyFactoryRSA.generatePrivate(clauPrivadaSpec);
								
				// Ara recuperem el certificat de la CA
				String nom4=r3;
				char[] password = r4.toCharArray();
				KeyStore magatzem;
				magatzem = KeyStore.getInstance("PKCS12", "BC");
				in = new FileInputStream(nom4);
				magatzem.load(in, password);
				in.close();
				CAcert = (X509Certificate) magatzem.getCertificate("Criptotal");
					
				X509V3CertificateGenerator certGen = new X509V3CertificateGenerator();
				String sujeto = "CN="+usuari;
				X500Principal dnName = new X500Principal(sujeto);
					
				BigInteger serialNumber = BigInteger.valueOf(nombre);
				certGen.setSerialNumber(serialNumber);
				certGen.setIssuerDN(CAcert.getSubjectX500Principal());
				certGen.setNotBefore(startDate);
				certGen.setNotAfter(expiryDate);
				certGen.setSubjectDN(dnName);                       		// Nota: El mateix que al issuer
				certGen.setPublicKey(clauPub);
				certGen.setSignatureAlgorithm("SHA256WithRSAEncryption");
				
				GeneralName gn = new GeneralName(GeneralName.uniformResourceIdentifier,new DERIA5String(r7));
				GeneralNames gns = new GeneralNames(new DERSequence(gn)); 
				DistributionPointName dpn = new DistributionPointName(0, gns); 
				DistributionPoint distp = new DistributionPoint(dpn, null, null); 
				certGen.addExtension(X509Extensions.CRLDistributionPoints, false, new DERSequence(distp));

					
				certGen.addExtension(X509Extensions.AuthorityKeyIdentifier, false, new AuthorityKeyIdentifierStructure(CAcert));
				certGen.addExtension(X509Extensions.SubjectKeyIdentifier, false, new SubjectKeyIdentifierStructure(clauPub));
				
				// Generem el certificat
				certUS = certGen.generate(CAKey, "BC");
					
				// Cormprovaci del certificat
				certUS.checkValidity(new Date());
				
				//certUS.verify(certUS.getPublicKey());
				certUS.verify(CAcert.getPublicKey());
								    
				// Guardem el certificat i la clau privada a un keyStore
				KeyStore magatzemUS = KeyStore.getInstance("PKCS12", "BC");
					    
				// El fiquem al Keystore
				magatzemUS.load(null, null);
				char[] contrasenya = r5.toCharArray();
				String aliasUS = "Usuari"+nombre;
				magatzemUS.setCertificateEntry(aliasUS, certUS);
				Certificate[] cadena = new Certificate[1];
				cadena[0] = certUS;
									
				//Guardem el Keystore
				nom5 = r6+nombre;
				FileOutputStream out = new FileOutputStream(nom5);
				password = r4.toCharArray();
				magatzemUS.store(out, password);
				out.close();

			} catch (NoSuchAlgorithmException e2) {
				System.out.println("No existeix aquest algorisme");
				e2.printStackTrace();
			} catch (NoSuchProviderException e2) {
				System.out.println("No existeix aquest proveidor de seguretat");
				e2.printStackTrace();
			} catch (CertificateParsingException e1) {
				System.out.println("Conversi de certificat no vlida");
				e1.printStackTrace();
			} catch (InvalidKeyException e) {
				System.out.println("Clau no vlida");
				e.printStackTrace();
			} catch (CertificateEncodingException e) {
				System.out.println("Codificaci del Certificat no vlida");
				e.printStackTrace();
			} catch (IllegalStateException e) {
				System.out.println("Estat no vlid");
				e.printStackTrace();
			} catch (SignatureException e) {
				System.out.println("Signatura no vlida");
				e.printStackTrace();
			} catch (CertificateExpiredException e) {
				System.out.println("Certificat expirat");
				e.printStackTrace();
			} catch (CertificateNotYetValidException e) {
				System.out.println("Certificat encara no vlid");
				e.printStackTrace();
			} catch (FileNotFoundException e) {
				System.out.println("El fitxer no existeix");
				e.printStackTrace();
			} catch (IOException e) {
				System.out.println("Problemes de lectura/escriptura");
				e.printStackTrace();
			} catch (InvalidKeySpecException e) {
				System.out.println("KeySpec no vlid");
				e.printStackTrace();
			} catch (KeyStoreException e) {
				System.out.println("KeyStore no vlid");
				e.printStackTrace();
			} catch (CertificateException e) {
				System.out.println("Certificat no vlid");
				e.printStackTrace();
			}
		
		} catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
		
		return nom5;
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
