package clasesJava;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.cert.X509CRL;
import java.sql.SQLException;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Servlet implementation class demanaCRL
 */
public class demanaCRL extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public demanaCRL() {
        super();
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		CRL crl = new CRL();
		List <Cert> lista = null;
		try {
			lista = crl.llistaCRL();
			if (lista.isEmpty()){
				System.out.println("ATENCI: No hi ha cap usuari revocat");
			}
		} catch (SQLException e) {
			System.out.println("ERROR: Problemes amb la BD");
			e.printStackTrace();
		}
		
		// Genera la CRL i afegeix els certificats
		CRLBC llista = new CRLBC();
		X509CRL crlBC = llista.creaCRL();
		
		Iterator iter = lista.iterator();
        while (iter.hasNext()){
        	Cert revo=(Cert) iter.next();
        	int serial = revo.getSerialNumber();
        	crlBC = llista.afegirCert(serial, crlBC);
        	lista.iterator().next();
        }
        
		// Convertir la lista en un fitxer i guardar-lo
        
        // Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("rutaCRL");
			
			try
	        {
	            FileOutputStream out = new FileOutputStream(r1);
				out.write(crlBC.getEncoded());
				out.close();   

	        } catch (Exception e) {
	            e.printStackTrace();
	        } 
	        
        } catch (IOException e1) {
			System.out.println("Excepci d'entrada-sortida");
			e1.printStackTrace();
		}
		
        response.sendRedirect("DescargarCRL.jsp");
        
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
