package clasesJava;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import java.security.*;
import java.security.spec.*;
import java.util.Properties;
import java.io.*;

public class parellClausCA {
	
	/**
	 * Constructor per defecte
	 */
	public parellClausCA(){
	}
	
	public void generaClausCA(){
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("clauCApriv");
			String r2=prop.getProperty("clauCApub");
			
			// Afegir provider BC
			Security.addProvider(new BouncyCastleProvider());
				            
			System.out.println("Comencem a generar les claus");

			// PAS 1: Crear i inicialitzar el parell de claus RSA DE 512 bits fent s del BC
			KeyPairGenerator keyGen;
			KeyPair clausRSA=null;
			try {
				keyGen = KeyPairGenerator.getInstance("RSA", "BC");
				keyGen.initialize(2048);
				clausRSA = keyGen.generateKeyPair();
				PrivateKey clauPrivada = clausRSA.getPrivate();
				PublicKey clauPublica = clausRSA.getPublic();
				
				System.out.println("Claus pblica i privada creades, anem a guardarles");
			      
				KeyFactory keyFactoryRSA = KeyFactory.getInstance("RSA", "BC");
				// PAS 2: Guardar les claus en arxius
				/*** 1 Pasos per posar la clau privada a un fitxer */
				// 1.1 Codificar clau privada en format PKCS8 (necessari per escriure-la al disc)
				PKCS8EncodedKeySpec pkcs8Spec = new PKCS8EncodedKeySpec(clauPrivada.getEncoded());

				// 1.2 Escriure-la a un fitxer binari
				FileOutputStream out = new FileOutputStream(r1);
				out.write(pkcs8Spec.getEncoded());
				out.close();

				/*** 2 Comprovaci de la clau privada del fitxer */
				// 2.1 Llegir les dades binaries
				byte[] bufferPriv = new byte[5000];
				FileInputStream in = new FileInputStream(r1);
				in.read(bufferPriv, 0, 5000);
				in.close();

				// 2.2 Recuperar la clau privada desde dades binaries a format PKCS8
				PKCS8EncodedKeySpec clauPrivadaSpec = new PKCS8EncodedKeySpec(bufferPriv);
				PrivateKey clauPrivada2;
				try {
					clauPrivada2 = keyFactoryRSA.generatePrivate(clauPrivadaSpec);
					if (clauPrivada.equals(clauPrivada2)) {
						System.out.println("OK: clau privada guardada i recuperada");
					}
				} catch (InvalidKeySpecException e) {
					System.out.println("KeySpec no vlid");
					e.printStackTrace();
				}
				
				/*** 3 Pasos per posar la clau pblica a un fitxer */
				// 3.1 Codificar clau pblica en format X509 (necessari per escriure-la al disc)
				X509EncodedKeySpec x509Spec = new X509EncodedKeySpec(clauPublica.getEncoded());

				// 3.2 Escriure-la a un fitxer binari
				out = new FileOutputStream(r2);
				out.write(x509Spec.getEncoded());
				out.close();

				/*** 4 Comprovaci de la clau pblica del fitxer */
				// 4.1 Llegir les dades binaries
				byte[] bufferPub = new byte[5000];
				in = new FileInputStream(r2);
				in.read(bufferPub, 0, 5000);
				in.close();

				// 4.2 Recuperar la clau pblica desde dades binaries a format X509
				X509EncodedKeySpec clauPublicaSpec = new X509EncodedKeySpec(bufferPub);
				PublicKey clauPublica2;
				try {
					clauPublica2 = keyFactoryRSA.generatePublic(clauPublicaSpec);
					if (clauPublica.equals(clauPublica2)) {
						System.out.println("OK: clau pblica guardada i recuperada");
					}
				} catch (InvalidKeySpecException e) {
					System.out.println("KeySpec no vlid");
					e.printStackTrace();
				}

			} catch (NoSuchAlgorithmException e) {
				System.out.println("No existeix aquest algorisme");
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				System.out.println("No existeix aquest proveidor de seguretat");
				e.printStackTrace();
			} catch (FileNotFoundException e) {
				System.out.println("El fitxer no existeix");
			}
			
		} catch (IOException e) {
				System.out.println("Problemes de lectura/escriptura");
		}
		
		return;
	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
