package clasesJava;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import java.security.*;
import java.security.spec.*;
import java.util.Properties;

public class parellClausUsuari {
	
	/**
	 * Constructor per defecte
	 */
	public parellClausUsuari(){
	}
	
	public void generaClausUsuari(int nombre){
		
		// Carrega les properties
		try {
			Properties prop = new Properties();
			prop = loadParams( "C:/TFC/rutas.properties" );
			String r1=prop.getProperty("rutaUS");
			
			// Afegir provider BC
			Security.addProvider(new BouncyCastleProvider());
				            
			// PAS 1: Crear i inicialitzar el parell de claus RSA DE 2048 bits fent s del BC
			KeyPairGenerator keyGen;
			KeyPair clausRSA=null;
			try {
				keyGen = KeyPairGenerator.getInstance("RSA", "BC");
				keyGen.initialize(2048);
				clausRSA = keyGen.generateKeyPair();
				PrivateKey clauPrivada = clausRSA.getPrivate();
				PublicKey clauPublica = clausRSA.getPublic();
				
				// PAS 2: Guardar les claus en arxius
				/*** 1 Pasos per posar la clau privada a un fitxer */
				// 1.1 Codificar clau privada en format PKS8 (necessari per escriure-la al disc)
				PKCS8EncodedKeySpec pkcs8Spec = new PKCS8EncodedKeySpec(clauPrivada.getEncoded());

				// 1.2 Escriure-la a un fitxer binari
				String nom1 = r1+nombre+".privada";
				FileOutputStream out = new FileOutputStream(nom1);
				out.write(pkcs8Spec.getEncoded());
				out.close();
				
				/*** 3 Pasos per posar la clau pblica a un fitxer */
				// 3.1 Codificar clau pblica en format X509 (necessari per escriure-la al disc)
				X509EncodedKeySpec x509Spec = new X509EncodedKeySpec(clauPublica.getEncoded());

				// 3.2 Escriure-la a un fitxer binari
				String nom2 = r1+nombre+".publica";
				out = new FileOutputStream(nom2);
				out.write(x509Spec.getEncoded());
				out.close();
				
			} catch (NoSuchAlgorithmException e) {
				System.out.println("No existeix aquest algorisme");
				e.printStackTrace();
			} catch (NoSuchProviderException e) {
				System.out.println("No existeix aquest proveidor de seguretat");
				e.printStackTrace();
			} catch (FileNotFoundException e) {
				System.out.println("El fitxer no existeix");
			}
		} catch (IOException e) {
			System.out.println("Problemes de lectura/escriptura");
		}
		
		return;

	}
	
	/**
	 * Maps a properties file to a Properties object
	 * @param file Properties file name
	 * @return Properties Properties object with the info from the file 
	 * @throws IOException Occurs if the file is not found
	 */
	private static Properties loadParams( String file )
		throws IOException {
		Properties prop = new Properties();
		prop.load(new FileInputStream (file));
		return prop;
	}

}
